%error = forceRequiredAddOn("Item_Skis");

if(%error == $Error::AddOn_Disabled)
{
	tumbleImpactAProjectile.uiName = "";
	skiImpactAProjectile.uiName = "";
	SkiItem.uiName = "";
}

%error = forceRequiredAddOn("Player_No_Jet");

if(%error == $Error::AddOn_Disabled)
{
	PlayerNoJet.uiName = "";
}

$UnconsciousPlayer::UnconsciousTime = 10000;

datablock PlayerData(PlayerUnconsciousData : PlayerNoJet)
{
	uiName = "Player - Unconscious";
};

function tumbleBetter(%player, %time, %force)
{
	//===========
	// Force
	//===========
	// 0 = Tumble for %time, then stop if it's safe. Regain control of
	//player after clicking.
	// 1 = Tumble for %time, then stop if it's safe. Regain control of
	//player automatically.
	// 2 = Tumble for %time, then stop wether it's safe or not. Regain
	//control of player after clicking.
	// 3 = Tumble for %time, then stop wether it's safe or not. Regain
	//control of player automatically.

	if(!isObject(%player))
	{
		return;
	}

	if(%player.getClassName() !$= "Player")
	{
		return;
	}

	if(%player.getState() $= "Dead")
	{
		return;
	}

	if(%time < -1)
	{
		%time = 2000;
	}

	%currVehicle = %player.getObjectMount();
	%client = %player.client;

	%newCar = new WheeledVehicle() 
	{
		dataBlock = deathVehicle;
		client = %client;
		initialPosition = %player.getPosition();
	};

	missionCleanup.add(%newCar);

	%newCar.setVelocity("0 0 0");

	if(!isObject(%newCar))
	{
		return;
	}

	%newCar.applyImpulse(%newCar.getPosition(), vectorScale(%newCar.getVelocity() * -1, %newCar.getDataBlock().mass));

	%player.canDismount = false;

	%newCar.setTransform(%player.getTransform());
	%newCar.applyImpulse( %newCar.getPosition(), vectorScale(%player.getVelocity(), %newCar.getDataBlock().mass));

	%newCar.mountObject(%player, 0);

	if(%time != -1)
	{
		%newCar.schedule(%time, tumbleCheckBetter, %force);
	}

	if(isObject(%client.camera))
	{
		%client.camera.setMode("Corpse", %player);
		%client.setControlObject(%client.camera);
	}
}

function vehicle::tumbleCheckBetter(%obj, %force)
{
	%obj.getDataBlock().tumbleCheckBetter(%obj, %force);
}

function deathVehicle::tumbleCheckBetter(%data, %obj, %force)
{
	%player = %obj.getMountedObject(0);
	%client = %player.client;

	if(vectorLen(%obj.getVelocity()) < 1 || %obj.getWaterCoverage() > 0.3 || %force >= 2)
	{
		if(isObject(%player))
		{
			%player.canDismount = true;
			%player.stopSkiing();
		}

		%obj.unMountObject(%player);
		%obj.schedule(0, delete);

		if(%force == 1 || %force >= 3)
		{
			if(isObject(%client))
			{
				%client.camera.getDataBlock().onTrigger(%client.camera, 0, 1);
				%client.camera.getDataBlock().schedule(50, onTrigger, %client.camera, 0, 0);
			}

			else
			{
				%player.setControlObject(%player);
			}
		}
	}

	else if(isObject(%player))
	{
		%obj.schedule(1000, tumbleCheckBetter, %force);
	}
}

package Player_Unconscious
{
	function armor::damage(%data, %player, %attacker, %pos, %damage, %type)
	{
		%newDamage = %data.maxDamage - %player.getDamageLevel();
		%newDamage -= %damage;

		if(%data.getName() $= "PlayerUnconsciousData" && %newDamage <= 0 && !%player.isUnconscious)
		{
			tumbleBetter(%player, $UnconsciousPlayer::UnconsciousTime, 1);
			%player.setWhiteOut(100);
			%player.setHealth(0.1);

			%player.isUnconscious = true;

			schedule($UnconsciousPlayer::UnconsciousTime, 0, eval, %player @ ".isUnconscious = false;");

			commandToClient(%player.client, 'centerPrint', "\c6You've been knocked unconscious!", 6);

			%damage = 0;
		}

		if(%player.isUnconscious)
		{
			%damage = 0;
		}

		return parent::damage(%data, %player, %attacker, %pos, %damage, %type);
	}

	function observer::onTrigger(%data, %cam, %slot, %bool)
	{
		if(%slot == 0 && %bool && isObject(%client = %cam.getControllingClient()))
		{
			if(isObject(%player = %client.player))
			{
				if(isObject(%vehicle = %player.getObjectMount()))
				{
					if(isObject(%data = %vehicle.getDataBlock()))
					{
						if(%data.getName() $= "deathVehicle")
						{
							return;
						}
					}
				}
			}
		}

		parent::onTrigger(%data, %cam, %slot, %bool);
	}
};
activatePackage(Player_Unconscious);